#
# simple rain test
#

import Image, PIL, math, string

def printLine ( line ):
	s = "     { "

	for i in line:
		s = s + str (i) + ", "

	s = s + "},"
	
	print s


im    = Image.open ( "drop-new.bmp" )
(w,h) = im.size

print "int xOffs[",w,"][", h,"] ="
print "{"

back = Image.open ( "17b.jpg" )

out = back.crop ( ( 0, 0, back.size [0], back.size [1] ) )

# now apply the drop

org = (20, 20)							# origin of drop

for y in range ( h ):

	count = 0							# count number of drop pixels

	for x in range ( w ):
		p = im.getpixel ( (x, y ) )		# pixel of drop

		if p == (0,0,255) :
			count = count + 1

	if count == 0:						# skip this line
		printLine ( range ( w ) )
		continue

	xStart = 0
	offs   = range ( w )

	for x in range ( w ):

		if im.getpixel ( ( x, y ) ) != ( 0, 0, 255 ):
			xStart   = xStart + 1
			offs [x] = x
		else:
			t    = float ( x - xStart ) / float ( count )
			f    = math.sqrt ( t ) * ( 1 - math.sqrt ( 1 - t ) )

			xNew = xStart + int ( f * count )
			offs [x] = xNew

			p = back.getpixel ( ( org [0] + xNew, org [1] + y ) )

			out.putpixel ( ( org [0] + x, org [1] + y ), p )

	printLine ( offs )

print "};"
print "int yOffs[", w, "][", h, "] = "
print "{"

for x in range ( w ):

	count = 0							# count number of drop pixels

	for y in range ( h ):
		p = im.getpixel ( (x, y ) )		# pixel of drop

		if p == (0,0,255) :
			count = count + 1

	if count == 0:						# skip this line
		printLine ( range ( h ) )
		continue

	yStart = 0
	offs   = range ( h )

	for y in range ( h ):

		if im.getpixel ( ( x, y ) ) != ( 0, 0, 255 ):
			yStart   = yStart + 1
			offs [y] = y
			continue

		t    = float ( y - yStart ) / float ( count )
		f    = math.sqrt ( t ) * ( 1 - math.sqrt ( 1 - t ) )

		yNew = yStart + int ( f * count )
		offs [y] = yNew

	printLine ( offs )

print "};"

